# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `BatchError.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Config_ice

# Start of module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')
__name__ = 'Smartswitch'

if 'BatchError' not in _M_Smartswitch.__dict__:
    _M_Smartswitch.BatchError = Ice.createTempClass()
    class BatchError(object):
        """
        @brief The struct contains the description of an error and a solution to work it around.
        It's used to return an exception which occurs on batch operations.
        We can't throw a regular exception in that case, because it indicates an error for the whole operation.
        While we need to indicate an error for a particular entry from the batch.
        Members:
        description -- < The error message which could be displayed to a user.
        solution -- < The possible way of working around the exception.
        """
        def __init__(self, description='', solution=''):
            self.description = description
            self.solution = solution

        def __hash__(self):
            _h = 0
            _h = 5 * _h + Ice.getHash(self.description)
            _h = 5 * _h + Ice.getHash(self.solution)
            return _h % 0x7fffffff

        def __compare(self, other):
            if other is None:
                return 1
            elif not isinstance(other, _M_Smartswitch.BatchError):
                return NotImplemented
            else:
                if self.description is None or other.description is None:
                    if self.description != other.description:
                        return (-1 if self.description is None else 1)
                else:
                    if self.description < other.description:
                        return -1
                    elif self.description > other.description:
                        return 1
                if self.solution is None or other.solution is None:
                    if self.solution != other.solution:
                        return (-1 if self.solution is None else 1)
                else:
                    if self.solution < other.solution:
                        return -1
                    elif self.solution > other.solution:
                        return 1
                return 0

        def __lt__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r < 0

        def __le__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r <= 0

        def __gt__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r > 0

        def __ge__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r >= 0

        def __eq__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r == 0

        def __ne__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r != 0

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch._t_BatchError)

        __repr__ = __str__

    _M_Smartswitch._t_BatchError = IcePy.defineStruct('::Smartswitch::BatchError', BatchError, (), (
        ('description', (), IcePy._t_string),
        ('solution', (), IcePy._t_string)
    ))

    _M_Smartswitch.BatchError = BatchError
    del BatchError

if '_t_BatchErrorOpt' not in _M_Smartswitch.__dict__:
    _M_Smartswitch._t_BatchErrorOpt = IcePy.defineSequence('::Smartswitch::BatchErrorOpt', (), _M_Smartswitch._t_BatchError)

# End of module Smartswitch
