# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `Currency.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Config_ice
import Smartswitch.Common_ice

# Included module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')

# Start of module Smartswitch
__name__ = 'Smartswitch'

# Start of module Smartswitch.Billing
_M_Smartswitch.Billing = Ice.openModule('Smartswitch.Billing')
__name__ = 'Smartswitch.Billing'

_M_Smartswitch.Billing._t_Currency = IcePy.defineValue('::Smartswitch::Billing::Currency', Ice.Value, -1, (), False, True, None, ())

if 'CurrencyPrx' not in _M_Smartswitch.Billing.__dict__:
    _M_Smartswitch.Billing.CurrencyPrx = Ice.createTempClass()
    class CurrencyPrx(Ice.ObjectPrx):

        """
        Obtain a name of a Currency.
        Arguments:
        context -- The request context for the invocation.
        Returns: The name of a currency, for example 'USD'.
        """
        def getName(self, context=None):
            return _M_Smartswitch.Billing.Currency._op_getName.invoke(self, ((), context))

        """
        Obtain a name of a Currency.
        Arguments:
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def getNameAsync(self, context=None):
            return _M_Smartswitch.Billing.Currency._op_getName.invokeAsync(self, ((), context))

        """
        Obtain a name of a Currency.
        Arguments:
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_getName(self, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Billing.Currency._op_getName.begin(self, ((), _response, _ex, _sent, context))

        """
        Obtain a name of a Currency.
        Arguments:
        Returns: The name of a currency, for example 'USD'.
        """
        def end_getName(self, _r):
            return _M_Smartswitch.Billing.Currency._op_getName.end(self, _r)

        """
        @brief Obtain the current rate of a Currency relative to `base currency` at a given time.
        A `base currency` is configured by the Smartswitch administrator.
        Smartswitch maintains the history of rate changes for each Currency.
        Therefore, you can get a snapshot of a currency rate value at any given time.
        Arguments:
        time -- The time we want to take a snapshot of `rate`.
        context -- The request context for the invocation.
        Returns: The rate of a Currency at a given `time`.
        """
        def getRate(self, time, context=None):
            return _M_Smartswitch.Billing.Currency._op_getRate.invoke(self, ((time, ), context))

        """
        @brief Obtain the current rate of a Currency relative to `base currency` at a given time.
        A `base currency` is configured by the Smartswitch administrator.
        Smartswitch maintains the history of rate changes for each Currency.
        Therefore, you can get a snapshot of a currency rate value at any given time.
        Arguments:
        time -- The time we want to take a snapshot of `rate`.
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def getRateAsync(self, time, context=None):
            return _M_Smartswitch.Billing.Currency._op_getRate.invokeAsync(self, ((time, ), context))

        """
        @brief Obtain the current rate of a Currency relative to `base currency` at a given time.
        A `base currency` is configured by the Smartswitch administrator.
        Smartswitch maintains the history of rate changes for each Currency.
        Therefore, you can get a snapshot of a currency rate value at any given time.
        Arguments:
        time -- The time we want to take a snapshot of `rate`.
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_getRate(self, time, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Billing.Currency._op_getRate.begin(self, ((time, ), _response, _ex, _sent, context))

        """
        @brief Obtain the current rate of a Currency relative to `base currency` at a given time.
        A `base currency` is configured by the Smartswitch administrator.
        Smartswitch maintains the history of rate changes for each Currency.
        Therefore, you can get a snapshot of a currency rate value at any given time.
        Arguments:
        time -- The time we want to take a snapshot of `rate`.
        Returns: The rate of a Currency at a given `time`.
        """
        def end_getRate(self, _r):
            return _M_Smartswitch.Billing.Currency._op_getRate.end(self, _r)

        @staticmethod
        def checkedCast(proxy, facetOrContext=None, context=None):
            return _M_Smartswitch.Billing.CurrencyPrx.ice_checkedCast(proxy, '::Smartswitch::Billing::Currency', facetOrContext, context)

        @staticmethod
        def uncheckedCast(proxy, facet=None):
            return _M_Smartswitch.Billing.CurrencyPrx.ice_uncheckedCast(proxy, facet)

        @staticmethod
        def ice_staticId():
            return '::Smartswitch::Billing::Currency'
    _M_Smartswitch.Billing._t_CurrencyPrx = IcePy.defineProxy('::Smartswitch::Billing::Currency', CurrencyPrx)

    _M_Smartswitch.Billing.CurrencyPrx = CurrencyPrx
    del CurrencyPrx

    _M_Smartswitch.Billing.Currency = Ice.createTempClass()
    class Currency(Ice.Object):

        def ice_ids(self, current=None):
            return ('::Ice::Object', '::Smartswitch::Billing::Currency')

        def ice_id(self, current=None):
            return '::Smartswitch::Billing::Currency'

        @staticmethod
        def ice_staticId():
            return '::Smartswitch::Billing::Currency'

        def getName(self, current=None):
            """
            Obtain a name of a Currency.
            Arguments:
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'getName' not implemented")

        def getRate(self, time, current=None):
            """
            @brief Obtain the current rate of a Currency relative to `base currency` at a given time.
            A `base currency` is configured by the Smartswitch administrator.
            Smartswitch maintains the history of rate changes for each Currency.
            Therefore, you can get a snapshot of a currency rate value at any given time.
            Arguments:
            time -- The time we want to take a snapshot of `rate`.
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'getRate' not implemented")

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Billing._t_CurrencyDisp)

        __repr__ = __str__

    _M_Smartswitch.Billing._t_CurrencyDisp = IcePy.defineClass('::Smartswitch::Billing::Currency', Currency, (), None, ())
    Currency._ice_type = _M_Smartswitch.Billing._t_CurrencyDisp

    Currency._op_getName = IcePy.Operation('getName', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (), (), ((), IcePy._t_string, False, 0), ())
    Currency._op_getRate = IcePy.Operation('getRate', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (((), IcePy._t_string, False, 0),), (), ((), _M_Smartswitch._t_DoubleOpt, False, 0), ())

    _M_Smartswitch.Billing.Currency = Currency
    del Currency

# End of module Smartswitch.Billing

__name__ = 'Smartswitch'

# End of module Smartswitch
