# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `Transaction.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Config_ice
import Smartswitch.Billing.CurrencyAmount_ice

# Included module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')

# Included module Smartswitch.Billing
_M_Smartswitch.Billing = Ice.openModule('Smartswitch.Billing')

# Start of module Smartswitch
__name__ = 'Smartswitch'

# Start of module Smartswitch.Billing
__name__ = 'Smartswitch.Billing'

if 'TransactionType' not in _M_Smartswitch.Billing.__dict__:
    _M_Smartswitch.Billing.TransactionType = Ice.createTempClass()
    class TransactionType(Ice.EnumBase):
        """
        A type of Transaction.
        Enumerators:
        Refill -- < Transaction is a balance refill.
        WriteOff -- < Transaction is a write-off from a balance.
        Payment -- < Transaction is an payment.
        Invoice -- < Transaction is an invoice.
        """

        def __init__(self, _n, _v):
            Ice.EnumBase.__init__(self, _n, _v)

        def valueOf(self, _n):
            if _n in self._enumerators:
                return self._enumerators[_n]
            return None
        valueOf = classmethod(valueOf)

    TransactionType.Refill = TransactionType("Refill", 0)
    TransactionType.WriteOff = TransactionType("WriteOff", 1)
    TransactionType.Payment = TransactionType("Payment", 2)
    TransactionType.Invoice = TransactionType("Invoice", 3)
    TransactionType._enumerators = { 0:TransactionType.Refill, 1:TransactionType.WriteOff, 2:TransactionType.Payment, 3:TransactionType.Invoice }

    _M_Smartswitch.Billing._t_TransactionType = IcePy.defineEnum('::Smartswitch::Billing::TransactionType', TransactionType, (), TransactionType._enumerators)

    _M_Smartswitch.Billing.TransactionType = TransactionType
    del TransactionType

if 'Transaction' not in _M_Smartswitch.Billing.__dict__:
    _M_Smartswitch.Billing.Transaction = Ice.createTempClass()
    class Transaction(object):
        """
        A Transaction connected with a balance.
        Members:
        type -- < The type of a transaction.
        date -- < The date the transaction has occured.
        amount -- < The amount of the transaction.
        """
        def __init__(self, type=_M_Smartswitch.Billing.TransactionType.Refill, date='', amount=Ice._struct_marker):
            self.type = type
            self.date = date
            if amount is Ice._struct_marker:
                self.amount = _M_Smartswitch.Billing.CurrencyAmount()
            else:
                self.amount = amount

        def __eq__(self, other):
            if other is None:
                return False
            elif not isinstance(other, _M_Smartswitch.Billing.Transaction):
                return NotImplemented
            else:
                if self.type != other.type:
                    return False
                if self.date != other.date:
                    return False
                if self.amount != other.amount:
                    return False
                return True

        def __ne__(self, other):
            return not self.__eq__(other)

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Billing._t_Transaction)

        __repr__ = __str__

    _M_Smartswitch.Billing._t_Transaction = IcePy.defineStruct('::Smartswitch::Billing::Transaction', Transaction, (), (
        ('type', (), _M_Smartswitch.Billing._t_TransactionType),
        ('date', (), IcePy._t_string),
        ('amount', (), _M_Smartswitch.Billing._t_CurrencyAmount)
    ))

    _M_Smartswitch.Billing.Transaction = Transaction
    del Transaction

if '_t_TransactionSequence' not in _M_Smartswitch.Billing.__dict__:
    _M_Smartswitch.Billing._t_TransactionSequence = IcePy.defineSequence('::Smartswitch::Billing::TransactionSequence', (), _M_Smartswitch.Billing._t_Transaction)

# End of module Smartswitch.Billing

__name__ = 'Smartswitch'

# End of module Smartswitch
