# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `ConcatenatedMessageInfo.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Config_ice

# Start of module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')
__name__ = 'Smartswitch'

# Start of module Smartswitch.Messaging
_M_Smartswitch.Messaging = Ice.openModule('Smartswitch.Messaging')
__name__ = 'Smartswitch.Messaging'

if 'ConcatenatedMessageInfo' not in _M_Smartswitch.Messaging.__dict__:
    _M_Smartswitch.Messaging.ConcatenatedMessageInfo = Ice.createTempClass()
    class ConcatenatedMessageInfo(object):
        """
        @brief The struct contains information needed to reassemble a full message from several segments.
        Some legacy messaging providers may accept only a message of small size.
        To send a big message we need to split a big message into smaller segments.
        Then we add a special header to each segment which is used to reassemble the big message back at the receiver side.
        And send these small messages to a provider consecutively.
        Members:
        messageIdentification -- < The unique ID of a message
        segmentCountTotal -- < Total count of segments to which a big message has been split.
        segmentNumberCurrent -- < The order number of a current segment amount other segments of the message.
        """
        def __init__(self, messageIdentification=0, segmentCountTotal=0, segmentNumberCurrent=0):
            self.messageIdentification = messageIdentification
            self.segmentCountTotal = segmentCountTotal
            self.segmentNumberCurrent = segmentNumberCurrent

        def __hash__(self):
            _h = 0
            _h = 5 * _h + Ice.getHash(self.messageIdentification)
            _h = 5 * _h + Ice.getHash(self.segmentCountTotal)
            _h = 5 * _h + Ice.getHash(self.segmentNumberCurrent)
            return _h % 0x7fffffff

        def __compare(self, other):
            if other is None:
                return 1
            elif not isinstance(other, _M_Smartswitch.Messaging.ConcatenatedMessageInfo):
                return NotImplemented
            else:
                if self.messageIdentification is None or other.messageIdentification is None:
                    if self.messageIdentification != other.messageIdentification:
                        return (-1 if self.messageIdentification is None else 1)
                else:
                    if self.messageIdentification < other.messageIdentification:
                        return -1
                    elif self.messageIdentification > other.messageIdentification:
                        return 1
                if self.segmentCountTotal is None or other.segmentCountTotal is None:
                    if self.segmentCountTotal != other.segmentCountTotal:
                        return (-1 if self.segmentCountTotal is None else 1)
                else:
                    if self.segmentCountTotal < other.segmentCountTotal:
                        return -1
                    elif self.segmentCountTotal > other.segmentCountTotal:
                        return 1
                if self.segmentNumberCurrent is None or other.segmentNumberCurrent is None:
                    if self.segmentNumberCurrent != other.segmentNumberCurrent:
                        return (-1 if self.segmentNumberCurrent is None else 1)
                else:
                    if self.segmentNumberCurrent < other.segmentNumberCurrent:
                        return -1
                    elif self.segmentNumberCurrent > other.segmentNumberCurrent:
                        return 1
                return 0

        def __lt__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r < 0

        def __le__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r <= 0

        def __gt__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r > 0

        def __ge__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r >= 0

        def __eq__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r == 0

        def __ne__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r != 0

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Messaging._t_ConcatenatedMessageInfo)

        __repr__ = __str__

    _M_Smartswitch.Messaging._t_ConcatenatedMessageInfo = IcePy.defineStruct('::Smartswitch::Messaging::ConcatenatedMessageInfo', ConcatenatedMessageInfo, (), (
        ('messageIdentification', (), IcePy._t_byte),
        ('segmentCountTotal', (), IcePy._t_byte),
        ('segmentNumberCurrent', (), IcePy._t_byte)
    ))

    _M_Smartswitch.Messaging.ConcatenatedMessageInfo = ConcatenatedMessageInfo
    del ConcatenatedMessageInfo

if '_t_ConcatenatedMessageInfoOpt' not in _M_Smartswitch.Messaging.__dict__:
    _M_Smartswitch.Messaging._t_ConcatenatedMessageInfoOpt = IcePy.defineSequence('::Smartswitch::Messaging::ConcatenatedMessageInfoOpt', (), _M_Smartswitch.Messaging._t_ConcatenatedMessageInfo)

# End of module Smartswitch.Messaging

__name__ = 'Smartswitch'

# End of module Smartswitch
