# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `Message.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Config_ice
import Smartswitch.Messaging.UserDataHeader_ice

# Included module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')

# Included module Smartswitch.Messaging
_M_Smartswitch.Messaging = Ice.openModule('Smartswitch.Messaging')

# Start of module Smartswitch
__name__ = 'Smartswitch'

# Start of module Smartswitch.Messaging
__name__ = 'Smartswitch.Messaging'

if 'Message' not in _M_Smartswitch.Messaging.__dict__:
    _M_Smartswitch.Messaging.Message = Ice.createTempClass()
    class Message(object):
        """
        This struct is used to send a Message.
        Members:
        sourceName -- < The name of a sender.
        sourceNumber -- < The number of a sender.
        destinationNumber -- < The number of a recepient.
        body -- < The body of a message encoded in UTF-8.
        requireDeliveryReceipt -- < `true` if sender requests recepient to send a Delivery Receipt.
        stealthPing -- 
        If sender requests Delivery Receipt together with this option, this allows to perform anonymous check if the subscriber is currently available.
        udh -- 
        On the SMPP layer this transforms to UDH or SAR protocol.
        """
        def __init__(self, sourceName='', sourceNumber='', destinationNumber='', body='', requireDeliveryReceipt=False, stealthPing=False, udh=Ice._struct_marker):
            self.sourceName = sourceName
            self.sourceNumber = sourceNumber
            self.destinationNumber = destinationNumber
            self.body = body
            self.requireDeliveryReceipt = requireDeliveryReceipt
            self.stealthPing = stealthPing
            if udh is Ice._struct_marker:
                self.udh = _M_Smartswitch.Messaging.UserDataHeader()
            else:
                self.udh = udh

        def __hash__(self):
            _h = 0
            _h = 5 * _h + Ice.getHash(self.sourceName)
            _h = 5 * _h + Ice.getHash(self.sourceNumber)
            _h = 5 * _h + Ice.getHash(self.destinationNumber)
            _h = 5 * _h + Ice.getHash(self.body)
            _h = 5 * _h + Ice.getHash(self.requireDeliveryReceipt)
            _h = 5 * _h + Ice.getHash(self.stealthPing)
            _h = 5 * _h + Ice.getHash(self.udh)
            return _h % 0x7fffffff

        def __compare(self, other):
            if other is None:
                return 1
            elif not isinstance(other, _M_Smartswitch.Messaging.Message):
                return NotImplemented
            else:
                if self.sourceName is None or other.sourceName is None:
                    if self.sourceName != other.sourceName:
                        return (-1 if self.sourceName is None else 1)
                else:
                    if self.sourceName < other.sourceName:
                        return -1
                    elif self.sourceName > other.sourceName:
                        return 1
                if self.sourceNumber is None or other.sourceNumber is None:
                    if self.sourceNumber != other.sourceNumber:
                        return (-1 if self.sourceNumber is None else 1)
                else:
                    if self.sourceNumber < other.sourceNumber:
                        return -1
                    elif self.sourceNumber > other.sourceNumber:
                        return 1
                if self.destinationNumber is None or other.destinationNumber is None:
                    if self.destinationNumber != other.destinationNumber:
                        return (-1 if self.destinationNumber is None else 1)
                else:
                    if self.destinationNumber < other.destinationNumber:
                        return -1
                    elif self.destinationNumber > other.destinationNumber:
                        return 1
                if self.body is None or other.body is None:
                    if self.body != other.body:
                        return (-1 if self.body is None else 1)
                else:
                    if self.body < other.body:
                        return -1
                    elif self.body > other.body:
                        return 1
                if self.requireDeliveryReceipt is None or other.requireDeliveryReceipt is None:
                    if self.requireDeliveryReceipt != other.requireDeliveryReceipt:
                        return (-1 if self.requireDeliveryReceipt is None else 1)
                else:
                    if self.requireDeliveryReceipt < other.requireDeliveryReceipt:
                        return -1
                    elif self.requireDeliveryReceipt > other.requireDeliveryReceipt:
                        return 1
                if self.stealthPing is None or other.stealthPing is None:
                    if self.stealthPing != other.stealthPing:
                        return (-1 if self.stealthPing is None else 1)
                else:
                    if self.stealthPing < other.stealthPing:
                        return -1
                    elif self.stealthPing > other.stealthPing:
                        return 1
                if self.udh is None or other.udh is None:
                    if self.udh != other.udh:
                        return (-1 if self.udh is None else 1)
                else:
                    if self.udh < other.udh:
                        return -1
                    elif self.udh > other.udh:
                        return 1
                return 0

        def __lt__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r < 0

        def __le__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r <= 0

        def __gt__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r > 0

        def __ge__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r >= 0

        def __eq__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r == 0

        def __ne__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r != 0

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Messaging._t_Message)

        __repr__ = __str__

    _M_Smartswitch.Messaging._t_Message = IcePy.defineStruct('::Smartswitch::Messaging::Message', Message, (), (
        ('sourceName', (), IcePy._t_string),
        ('sourceNumber', (), IcePy._t_string),
        ('destinationNumber', (), IcePy._t_string),
        ('body', (), IcePy._t_string),
        ('requireDeliveryReceipt', (), IcePy._t_bool),
        ('stealthPing', (), IcePy._t_bool),
        ('udh', (), _M_Smartswitch.Messaging._t_UserDataHeader)
    ))

    _M_Smartswitch.Messaging.Message = Message
    del Message

if '_t_MessageSequence' not in _M_Smartswitch.Messaging.__dict__:
    _M_Smartswitch.Messaging._t_MessageSequence = IcePy.defineSequence('::Smartswitch::Messaging::MessageSequence', (), _M_Smartswitch.Messaging._t_Message)

# End of module Smartswitch.Messaging

__name__ = 'Smartswitch'

# End of module Smartswitch
