# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `Company.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Config_ice
import Glacier2.Session_ice
import Smartswitch.Common_ice
import Smartswitch.Destroyable_ice
import Smartswitch.AccessException_ice
import Smartswitch.Billing.CurrencyAmount_ice
import Smartswitch.Billing.Service_ice

# Included module Ice
_M_Ice = Ice.openModule('Ice')

# Included module Glacier2
_M_Glacier2 = Ice.openModule('Glacier2')

# Included module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')

# Included module Smartswitch.Billing
_M_Smartswitch.Billing = Ice.openModule('Smartswitch.Billing')

# Start of module Smartswitch
__name__ = 'Smartswitch'

# Start of module Smartswitch.Peer
_M_Smartswitch.Peer = Ice.openModule('Smartswitch.Peer')
__name__ = 'Smartswitch.Peer'

if 'CompanyBalance' not in _M_Smartswitch.Peer.__dict__:
    _M_Smartswitch.Peer.CompanyBalance = Ice.createTempClass()
    class CompanyBalance(Ice.EnumBase):
        """
        Selects type of a Company balance.
        Enumerators:
        Their -- < The balance of a Company at our side.
        Our -- < Our balance at Company side.
        Mutual -- < `Their` balance - `Our` balance.
        """

        def __init__(self, _n, _v):
            Ice.EnumBase.__init__(self, _n, _v)

        def valueOf(self, _n):
            if _n in self._enumerators:
                return self._enumerators[_n]
            return None
        valueOf = classmethod(valueOf)

    CompanyBalance.Their = CompanyBalance("Their", 0)
    CompanyBalance.Our = CompanyBalance("Our", 1)
    CompanyBalance.Mutual = CompanyBalance("Mutual", 2)
    CompanyBalance._enumerators = { 0:CompanyBalance.Their, 1:CompanyBalance.Our, 2:CompanyBalance.Mutual }

    _M_Smartswitch.Peer._t_CompanyBalance = IcePy.defineEnum('::Smartswitch::Peer::CompanyBalance', CompanyBalance, (), CompanyBalance._enumerators)

    _M_Smartswitch.Peer.CompanyBalance = CompanyBalance
    del CompanyBalance

if 'ApplyToBalance' not in _M_Smartswitch.Peer.__dict__:
    _M_Smartswitch.Peer.ApplyToBalance = Ice.createTempClass()
    class ApplyToBalance(Ice.EnumBase):
        """
        Selects type of a Company balance to which to apply a Transaction.
        Enumerators:
        Their -- < Apply to `Their` balance.
        Our -- < Apply to `Our` balance.
        """

        def __init__(self, _n, _v):
            Ice.EnumBase.__init__(self, _n, _v)

        def valueOf(self, _n):
            if _n in self._enumerators:
                return self._enumerators[_n]
            return None
        valueOf = classmethod(valueOf)

    ApplyToBalance.Their = ApplyToBalance("Their", 0)
    ApplyToBalance.Our = ApplyToBalance("Our", 1)
    ApplyToBalance._enumerators = { 0:ApplyToBalance.Their, 1:ApplyToBalance.Our }

    _M_Smartswitch.Peer._t_ApplyToBalance = IcePy.defineEnum('::Smartswitch::Peer::ApplyToBalance', ApplyToBalance, (), ApplyToBalance._enumerators)

    _M_Smartswitch.Peer.ApplyToBalance = ApplyToBalance
    del ApplyToBalance

_M_Smartswitch.Peer._t_Company = IcePy.defineValue('::Smartswitch::Peer::Company', Ice.Value, -1, (), False, True, None, ())

if 'CompanyPrx' not in _M_Smartswitch.Peer.__dict__:
    _M_Smartswitch.Peer.CompanyPrx = Ice.createTempClass()
    class CompanyPrx(_M_Smartswitch.DestroyablePrx):

        """
        Obtain the unique constant ID of a Company.
        Arguments:
        context -- The request context for the invocation.
        Returns: unique ID of a Company
        """
        def getId(self, context=None):
            return _M_Smartswitch.Peer.Company._op_getId.invoke(self, ((), context))

        """
        Obtain the unique constant ID of a Company.
        Arguments:
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def getIdAsync(self, context=None):
            return _M_Smartswitch.Peer.Company._op_getId.invokeAsync(self, ((), context))

        """
        Obtain the unique constant ID of a Company.
        Arguments:
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_getId(self, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Peer.Company._op_getId.begin(self, ((), _response, _ex, _sent, context))

        """
        Obtain the unique constant ID of a Company.
        Arguments:
        Returns: unique ID of a Company
        """
        def end_getId(self, _r):
            return _M_Smartswitch.Peer.Company._op_getId.end(self, _r)

        """
        Obtain the name of a Company.
        Arguments:
        context -- The request context for the invocation.
        Returns: name of a Company
        """
        def getName(self, context=None):
            return _M_Smartswitch.Peer.Company._op_getName.invoke(self, ((), context))

        """
        Obtain the name of a Company.
        Arguments:
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def getNameAsync(self, context=None):
            return _M_Smartswitch.Peer.Company._op_getName.invokeAsync(self, ((), context))

        """
        Obtain the name of a Company.
        Arguments:
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_getName(self, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Peer.Company._op_getName.begin(self, ((), _response, _ex, _sent, context))

        """
        Obtain the name of a Company.
        Arguments:
        Returns: name of a Company
        """
        def end_getName(self, _r):
            return _M_Smartswitch.Peer.Company._op_getName.end(self, _r)

        """
        @brief Activate the Company.
        When the Company is activated, we may perform periodical write-offs of a subscriber fee (if configured).
        When the Company is deactivated, we will block the services provision.
        Arguments:
        activated -- 
        context -- The request context for the invocation.
        """
        def setActivated(self, activated, context=None):
            return _M_Smartswitch.Peer.Company._op_setActivated.invoke(self, ((activated, ), context))

        """
        @brief Activate the Company.
        When the Company is activated, we may perform periodical write-offs of a subscriber fee (if configured).
        When the Company is deactivated, we will block the services provision.
        Arguments:
        activated -- 
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def setActivatedAsync(self, activated, context=None):
            return _M_Smartswitch.Peer.Company._op_setActivated.invokeAsync(self, ((activated, ), context))

        """
        @brief Activate the Company.
        When the Company is activated, we may perform periodical write-offs of a subscriber fee (if configured).
        When the Company is deactivated, we will block the services provision.
        Arguments:
        activated -- 
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_setActivated(self, activated, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Peer.Company._op_setActivated.begin(self, ((activated, ), _response, _ex, _sent, context))

        """
        @brief Activate the Company.
        When the Company is activated, we may perform periodical write-offs of a subscriber fee (if configured).
        When the Company is deactivated, we will block the services provision.
        Arguments:
        activated -- 
        """
        def end_setActivated(self, _r):
            return _M_Smartswitch.Peer.Company._op_setActivated.end(self, _r)

        """
        Check if the Company is currently active.
        Arguments:
        context -- The request context for the invocation.
        Returns: `true` if the Company is activated.
        """
        def isActivated(self, context=None):
            return _M_Smartswitch.Peer.Company._op_isActivated.invoke(self, ((), context))

        """
        Check if the Company is currently active.
        Arguments:
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def isActivatedAsync(self, context=None):
            return _M_Smartswitch.Peer.Company._op_isActivated.invokeAsync(self, ((), context))

        """
        Check if the Company is currently active.
        Arguments:
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_isActivated(self, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Peer.Company._op_isActivated.begin(self, ((), _response, _ex, _sent, context))

        """
        Check if the Company is currently active.
        Arguments:
        Returns: `true` if the Company is activated.
        """
        def end_isActivated(self, _r):
            return _M_Smartswitch.Peer.Company._op_isActivated.end(self, _r)

        """
        Obtain the current Company balance
        Arguments:
        which -- Which Company balance to obtain
        context -- The request context for the invocation.
        Returns: Current balance of a Company.
        """
        def getBalance(self, which, context=None):
            return _M_Smartswitch.Peer.Company._op_getBalance.invoke(self, ((which, ), context))

        """
        Obtain the current Company balance
        Arguments:
        which -- Which Company balance to obtain
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def getBalanceAsync(self, which, context=None):
            return _M_Smartswitch.Peer.Company._op_getBalance.invokeAsync(self, ((which, ), context))

        """
        Obtain the current Company balance
        Arguments:
        which -- Which Company balance to obtain
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_getBalance(self, which, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Peer.Company._op_getBalance.begin(self, ((which, ), _response, _ex, _sent, context))

        """
        Obtain the current Company balance
        Arguments:
        which -- Which Company balance to obtain
        Returns: Current balance of a Company.
        """
        def end_getBalance(self, _r):
            return _M_Smartswitch.Peer.Company._op_getBalance.end(self, _r)

        """
        Refill the Company balance.
        Arguments:
        apply -- Which balance to refill
        service -- Which Service to bind to this transaction
        amount -- The amount to refill the Company balance
        context -- The request context for the invocation.
        Returns: `true` if operation finished successfully.
        """
        def refill(self, apply, service, amount, context=None):
            return _M_Smartswitch.Peer.Company._op_refill.invoke(self, ((apply, service, amount), context))

        """
        Refill the Company balance.
        Arguments:
        apply -- Which balance to refill
        service -- Which Service to bind to this transaction
        amount -- The amount to refill the Company balance
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def refillAsync(self, apply, service, amount, context=None):
            return _M_Smartswitch.Peer.Company._op_refill.invokeAsync(self, ((apply, service, amount), context))

        """
        Refill the Company balance.
        Arguments:
        apply -- Which balance to refill
        service -- Which Service to bind to this transaction
        amount -- The amount to refill the Company balance
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_refill(self, apply, service, amount, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Peer.Company._op_refill.begin(self, ((apply, service, amount), _response, _ex, _sent, context))

        """
        Refill the Company balance.
        Arguments:
        apply -- Which balance to refill
        service -- Which Service to bind to this transaction
        amount -- The amount to refill the Company balance
        Returns: `true` if operation finished successfully.
        """
        def end_refill(self, _r):
            return _M_Smartswitch.Peer.Company._op_refill.end(self, _r)

        """
        Write-off from the Company balance.
        Arguments:
        apply -- Which balance to write-off from
        service -- Which Service to bind to this transaction (will be reflected in the invoice to the Company)
        amount -- The amount to write-off the Company balance
        context -- The request context for the invocation.
        Returns: `true` if operation finished successfully.
        """
        def writeOff(self, apply, service, amount, context=None):
            return _M_Smartswitch.Peer.Company._op_writeOff.invoke(self, ((apply, service, amount), context))

        """
        Write-off from the Company balance.
        Arguments:
        apply -- Which balance to write-off from
        service -- Which Service to bind to this transaction (will be reflected in the invoice to the Company)
        amount -- The amount to write-off the Company balance
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def writeOffAsync(self, apply, service, amount, context=None):
            return _M_Smartswitch.Peer.Company._op_writeOff.invokeAsync(self, ((apply, service, amount), context))

        """
        Write-off from the Company balance.
        Arguments:
        apply -- Which balance to write-off from
        service -- Which Service to bind to this transaction (will be reflected in the invoice to the Company)
        amount -- The amount to write-off the Company balance
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_writeOff(self, apply, service, amount, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Peer.Company._op_writeOff.begin(self, ((apply, service, amount), _response, _ex, _sent, context))

        """
        Write-off from the Company balance.
        Arguments:
        apply -- Which balance to write-off from
        service -- Which Service to bind to this transaction (will be reflected in the invoice to the Company)
        amount -- The amount to write-off the Company balance
        Returns: `true` if operation finished successfully.
        """
        def end_writeOff(self, _r):
            return _M_Smartswitch.Peer.Company._op_writeOff.end(self, _r)

        @staticmethod
        def checkedCast(proxy, facetOrContext=None, context=None):
            return _M_Smartswitch.Peer.CompanyPrx.ice_checkedCast(proxy, '::Smartswitch::Peer::Company', facetOrContext, context)

        @staticmethod
        def uncheckedCast(proxy, facet=None):
            return _M_Smartswitch.Peer.CompanyPrx.ice_uncheckedCast(proxy, facet)

        @staticmethod
        def ice_staticId():
            return '::Smartswitch::Peer::Company'
    _M_Smartswitch.Peer._t_CompanyPrx = IcePy.defineProxy('::Smartswitch::Peer::Company', CompanyPrx)

    _M_Smartswitch.Peer.CompanyPrx = CompanyPrx
    del CompanyPrx

    _M_Smartswitch.Peer.Company = Ice.createTempClass()
    class Company(_M_Smartswitch.Destroyable):

        def ice_ids(self, current=None):
            return ('::Ice::Object', '::Smartswitch::Destroyable', '::Smartswitch::Peer::Company')

        def ice_id(self, current=None):
            return '::Smartswitch::Peer::Company'

        @staticmethod
        def ice_staticId():
            return '::Smartswitch::Peer::Company'

        def getId(self, current=None):
            """
            Obtain the unique constant ID of a Company.
            Arguments:
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'getId' not implemented")

        def getName(self, current=None):
            """
            Obtain the name of a Company.
            Arguments:
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'getName' not implemented")

        def setActivated(self, activated, current=None):
            """
            @brief Activate the Company.
            When the Company is activated, we may perform periodical write-offs of a subscriber fee (if configured).
            When the Company is deactivated, we will block the services provision.
            Arguments:
            activated -- 
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'setActivated' not implemented")

        def isActivated(self, current=None):
            """
            Check if the Company is currently active.
            Arguments:
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'isActivated' not implemented")

        def getBalance(self, which, current=None):
            """
            Obtain the current Company balance
            Arguments:
            which -- Which Company balance to obtain
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'getBalance' not implemented")

        def refill(self, apply, service, amount, current=None):
            """
            Refill the Company balance.
            Arguments:
            apply -- Which balance to refill
            service -- Which Service to bind to this transaction
            amount -- The amount to refill the Company balance
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'refill' not implemented")

        def writeOff(self, apply, service, amount, current=None):
            """
            Write-off from the Company balance.
            Arguments:
            apply -- Which balance to write-off from
            service -- Which Service to bind to this transaction (will be reflected in the invoice to the Company)
            amount -- The amount to write-off the Company balance
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'writeOff' not implemented")

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Peer._t_CompanyDisp)

        __repr__ = __str__

    _M_Smartswitch.Peer._t_CompanyDisp = IcePy.defineClass('::Smartswitch::Peer::Company', Company, (), None, (_M_Smartswitch._t_DestroyableDisp,))
    Company._ice_type = _M_Smartswitch.Peer._t_CompanyDisp

    Company._op_getId = IcePy.Operation('getId', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (), (), ((), IcePy._t_long, False, 0), ())
    Company._op_getName = IcePy.Operation('getName', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (), (), ((), IcePy._t_string, False, 0), (_M_Smartswitch._t_AccessException,))
    Company._op_setActivated = IcePy.Operation('setActivated', Ice.OperationMode.Normal, Ice.OperationMode.Normal, False, None, (), (((), IcePy._t_bool, False, 0),), (), None, ())
    Company._op_isActivated = IcePy.Operation('isActivated', Ice.OperationMode.Normal, Ice.OperationMode.Normal, False, None, (), (), (), ((), IcePy._t_bool, False, 0), ())
    Company._op_getBalance = IcePy.Operation('getBalance', Ice.OperationMode.Normal, Ice.OperationMode.Normal, False, None, (), (((), _M_Smartswitch.Peer._t_CompanyBalance, False, 0),), (), ((), _M_Smartswitch.Billing._t_CurrencyAmountSequence, False, 0), (_M_Smartswitch._t_AccessException,))
    Company._op_refill = IcePy.Operation('refill', Ice.OperationMode.Normal, Ice.OperationMode.Normal, False, None, (), (((), _M_Smartswitch.Peer._t_ApplyToBalance, False, 0), ((), _M_Smartswitch.Billing._t_ServicePrx, False, 0), ((), _M_Smartswitch.Billing._t_CurrencyAmount, False, 0)), (), ((), IcePy._t_bool, False, 0), (_M_Smartswitch._t_AccessException,))
    Company._op_writeOff = IcePy.Operation('writeOff', Ice.OperationMode.Normal, Ice.OperationMode.Normal, False, None, (), (((), _M_Smartswitch.Peer._t_ApplyToBalance, False, 0), ((), _M_Smartswitch.Billing._t_ServicePrx, False, 0), ((), _M_Smartswitch.Billing._t_CurrencyAmount, False, 0)), (), ((), IcePy._t_bool, False, 0), (_M_Smartswitch._t_AccessException,))

    _M_Smartswitch.Peer.Company = Company
    del Company

# End of module Smartswitch.Peer

__name__ = 'Smartswitch'

# End of module Smartswitch
