# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `UserInfo.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Config_ice

# Start of module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')
__name__ = 'Smartswitch'

# Start of module Smartswitch.Peer
_M_Smartswitch.Peer = Ice.openModule('Smartswitch.Peer')
__name__ = 'Smartswitch.Peer'

# Start of module Smartswitch.Peer.UserGeneration
_M_Smartswitch.Peer.UserGeneration = Ice.openModule('Smartswitch.Peer.UserGeneration')
__name__ = 'Smartswitch.Peer.UserGeneration'

if 'UserInfo' not in _M_Smartswitch.Peer.UserGeneration.__dict__:
    _M_Smartswitch.Peer.UserGeneration.UserInfo = Ice.createTempClass()
    class UserInfo(object):
        """
        @brief The information which is returned after generation of a User.
        Some of this information is available only once after User generation.
        For example, the password, which later could only be changed, but not read.
        Members:
        id -- < The unique ID of a User.
        name -- < The name of a User.
        sipSecret -- < The secret used for SIP authentication.
        login -- < The login for web access.
        password -- < The password for web access.
        pin -- < The PIN used for DTMF authentication.
        pjsipSecret -- < The secret used for PJSIP authentication.
        """
        def __init__(self, id=0, name='', sipSecret='', login='', password='', pin='', pjsipSecret=''):
            self.id = id
            self.name = name
            self.sipSecret = sipSecret
            self.login = login
            self.password = password
            self.pin = pin
            self.pjsipSecret = pjsipSecret

        def __hash__(self):
            _h = 0
            _h = 5 * _h + Ice.getHash(self.id)
            _h = 5 * _h + Ice.getHash(self.name)
            _h = 5 * _h + Ice.getHash(self.sipSecret)
            _h = 5 * _h + Ice.getHash(self.login)
            _h = 5 * _h + Ice.getHash(self.password)
            _h = 5 * _h + Ice.getHash(self.pin)
            _h = 5 * _h + Ice.getHash(self.pjsipSecret)
            return _h % 0x7fffffff

        def __compare(self, other):
            if other is None:
                return 1
            elif not isinstance(other, _M_Smartswitch.Peer.UserGeneration.UserInfo):
                return NotImplemented
            else:
                if self.id is None or other.id is None:
                    if self.id != other.id:
                        return (-1 if self.id is None else 1)
                else:
                    if self.id < other.id:
                        return -1
                    elif self.id > other.id:
                        return 1
                if self.name is None or other.name is None:
                    if self.name != other.name:
                        return (-1 if self.name is None else 1)
                else:
                    if self.name < other.name:
                        return -1
                    elif self.name > other.name:
                        return 1
                if self.sipSecret is None or other.sipSecret is None:
                    if self.sipSecret != other.sipSecret:
                        return (-1 if self.sipSecret is None else 1)
                else:
                    if self.sipSecret < other.sipSecret:
                        return -1
                    elif self.sipSecret > other.sipSecret:
                        return 1
                if self.login is None or other.login is None:
                    if self.login != other.login:
                        return (-1 if self.login is None else 1)
                else:
                    if self.login < other.login:
                        return -1
                    elif self.login > other.login:
                        return 1
                if self.password is None or other.password is None:
                    if self.password != other.password:
                        return (-1 if self.password is None else 1)
                else:
                    if self.password < other.password:
                        return -1
                    elif self.password > other.password:
                        return 1
                if self.pin is None or other.pin is None:
                    if self.pin != other.pin:
                        return (-1 if self.pin is None else 1)
                else:
                    if self.pin < other.pin:
                        return -1
                    elif self.pin > other.pin:
                        return 1
                if self.pjsipSecret is None or other.pjsipSecret is None:
                    if self.pjsipSecret != other.pjsipSecret:
                        return (-1 if self.pjsipSecret is None else 1)
                else:
                    if self.pjsipSecret < other.pjsipSecret:
                        return -1
                    elif self.pjsipSecret > other.pjsipSecret:
                        return 1
                return 0

        def __lt__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r < 0

        def __le__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r <= 0

        def __gt__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r > 0

        def __ge__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r >= 0

        def __eq__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r == 0

        def __ne__(self, other):
            r = self.__compare(other)
            if r is NotImplemented:
                return r
            else:
                return r != 0

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Peer.UserGeneration._t_UserInfo)

        __repr__ = __str__

    _M_Smartswitch.Peer.UserGeneration._t_UserInfo = IcePy.defineStruct('::Smartswitch::Peer::UserGeneration::UserInfo', UserInfo, (), (
        ('id', (), IcePy._t_long),
        ('name', (), IcePy._t_string),
        ('sipSecret', (), IcePy._t_string),
        ('login', (), IcePy._t_string),
        ('password', (), IcePy._t_string),
        ('pin', (), IcePy._t_string),
        ('pjsipSecret', (), IcePy._t_string)
    ))

    _M_Smartswitch.Peer.UserGeneration.UserInfo = UserInfo
    del UserInfo

if '_t_UserInfoSequence' not in _M_Smartswitch.Peer.UserGeneration.__dict__:
    _M_Smartswitch.Peer.UserGeneration._t_UserInfoSequence = IcePy.defineSequence('::Smartswitch::Peer::UserGeneration::UserInfoSequence', (), _M_Smartswitch.Peer.UserGeneration._t_UserInfo)

# End of module Smartswitch.Peer.UserGeneration

__name__ = 'Smartswitch.Peer'

# End of module Smartswitch.Peer

__name__ = 'Smartswitch'

# End of module Smartswitch
