# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `WeakPasswordException.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.GenericException_ice

# Included module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')

# Start of module Smartswitch
__name__ = 'Smartswitch'

# Start of module Smartswitch.Peer
_M_Smartswitch.Peer = Ice.openModule('Smartswitch.Peer')
__name__ = 'Smartswitch.Peer'

# Start of module Smartswitch.Peer.UserGeneration
_M_Smartswitch.Peer.UserGeneration = Ice.openModule('Smartswitch.Peer.UserGeneration')
__name__ = 'Smartswitch.Peer.UserGeneration'

if 'WeakPasswordException' not in _M_Smartswitch.Peer.UserGeneration.__dict__:
    _M_Smartswitch.Peer.UserGeneration.WeakPasswordException = Ice.createTempClass()
    class WeakPasswordException(_M_Smartswitch.GenericException):
        """
        @brief This exception is thrown when there is no more attempts left to generate a strong password for a User.
        When generating a User, Smartswitch tries to generate random password for a User basing on password generation template which is set in a User generation profile.
        Then Smartswitch checks if a newly generated password is strong enough.
        If the check fails, Smartswitch tries to generate another random password.
        The amount of attempts to generate a strong password is defined at User generation profile.
        If Smartswitch is unable to generate a strong password in a given amount of attempts, this exception is thrown.
        Members:
        attempts -- < The count of attempts to generate a strong password for a User which has been performed.
        """
        def __init__(self, description='', solution='', attempts=0):
            _M_Smartswitch.GenericException.__init__(self, description, solution)
            self.attempts = attempts

        def __str__(self):
            return IcePy.stringifyException(self)

        __repr__ = __str__

        _ice_id = '::Smartswitch::Peer::UserGeneration::WeakPasswordException'

    _M_Smartswitch.Peer.UserGeneration._t_WeakPasswordException = IcePy.defineException('::Smartswitch::Peer::UserGeneration::WeakPasswordException', WeakPasswordException, (), False, _M_Smartswitch._t_GenericException, (('attempts', (), IcePy._t_int, False, 0),))
    WeakPasswordException._ice_type = _M_Smartswitch.Peer.UserGeneration._t_WeakPasswordException

    _M_Smartswitch.Peer.UserGeneration.WeakPasswordException = WeakPasswordException
    del WeakPasswordException

# End of module Smartswitch.Peer.UserGeneration

__name__ = 'Smartswitch.Peer'

# End of module Smartswitch.Peer

__name__ = 'Smartswitch'

# End of module Smartswitch
