# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `UserGroup.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Peer.GenericPeer_ice
import Smartswitch.Peer.UserCallerId_ice

# Included module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')

# Included module Ice
_M_Ice = Ice.openModule('Ice')

# Included module Glacier2
_M_Glacier2 = Ice.openModule('Glacier2')

# Included module Smartswitch.Billing
_M_Smartswitch.Billing = Ice.openModule('Smartswitch.Billing')

# Included module Smartswitch.Peer
_M_Smartswitch.Peer = Ice.openModule('Smartswitch.Peer')

# Start of module Smartswitch
__name__ = 'Smartswitch'

# Start of module Smartswitch.Peer
__name__ = 'Smartswitch.Peer'

_M_Smartswitch.Peer._t_UserGroup = IcePy.defineValue('::Smartswitch::Peer::UserGroup', Ice.Value, -1, (), False, True, None, ())

if 'UserGroupPrx' not in _M_Smartswitch.Peer.__dict__:
    _M_Smartswitch.Peer.UserGroupPrx = Ice.createTempClass()
    class UserGroupPrx(_M_Smartswitch.Peer.GenericPeerPrx):

        """
        @brief Obtain the UserCallerId objects attached to the UserGroup.
        These settings are used by the Smartswitch to replace a caller number and caller name for the calls from any User of the UserGroup.
        This is needed to bind a specific A-number and A-name to the user, so that he won't be able to call using other user's caller information.
        The latter is considered a crime in many countries and thus it's needed to use this function in a safe User configuration.
        Arguments:
        context -- The request context for the invocation.
        Returns: The sequence of UserCallerId objects attached to the UserGroup.
        """
        def getCallerIds(self, context=None):
            return _M_Smartswitch.Peer.UserGroup._op_getCallerIds.invoke(self, ((), context))

        """
        @brief Obtain the UserCallerId objects attached to the UserGroup.
        These settings are used by the Smartswitch to replace a caller number and caller name for the calls from any User of the UserGroup.
        This is needed to bind a specific A-number and A-name to the user, so that he won't be able to call using other user's caller information.
        The latter is considered a crime in many countries and thus it's needed to use this function in a safe User configuration.
        Arguments:
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def getCallerIdsAsync(self, context=None):
            return _M_Smartswitch.Peer.UserGroup._op_getCallerIds.invokeAsync(self, ((), context))

        """
        @brief Obtain the UserCallerId objects attached to the UserGroup.
        These settings are used by the Smartswitch to replace a caller number and caller name for the calls from any User of the UserGroup.
        This is needed to bind a specific A-number and A-name to the user, so that he won't be able to call using other user's caller information.
        The latter is considered a crime in many countries and thus it's needed to use this function in a safe User configuration.
        Arguments:
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_getCallerIds(self, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Peer.UserGroup._op_getCallerIds.begin(self, ((), _response, _ex, _sent, context))

        """
        @brief Obtain the UserCallerId objects attached to the UserGroup.
        These settings are used by the Smartswitch to replace a caller number and caller name for the calls from any User of the UserGroup.
        This is needed to bind a specific A-number and A-name to the user, so that he won't be able to call using other user's caller information.
        The latter is considered a crime in many countries and thus it's needed to use this function in a safe User configuration.
        Arguments:
        Returns: The sequence of UserCallerId objects attached to the UserGroup.
        """
        def end_getCallerIds(self, _r):
            return _M_Smartswitch.Peer.UserGroup._op_getCallerIds.end(self, _r)

        """
        @brief Attach the new UserCallerId replacement rule to the UserGroup.
        Arguments:
        callerNumber -- The caller number to bind to the UserGroup.
        calleeIdPattern -- Use above caller number of the callee number matches this pattern. Pass empty to match any callee number.
        realCalleeIdPattern -- Use above caller number of the real callee number (a number with prefix) matches this pattern. This could be used if you want to allow user to pick up a specific caller number by adding a prefix to a called number. Pass empty to match any real callee number.
        context -- The request context for the invocation.
        Returns: The proxy for UserCallerId which is attached to the UserGroup.
        """
        def addCallerId(self, callerNumber, calleeIdPattern, realCalleeIdPattern, context=None):
            return _M_Smartswitch.Peer.UserGroup._op_addCallerId.invoke(self, ((callerNumber, calleeIdPattern, realCalleeIdPattern), context))

        """
        @brief Attach the new UserCallerId replacement rule to the UserGroup.
        Arguments:
        callerNumber -- The caller number to bind to the UserGroup.
        calleeIdPattern -- Use above caller number of the callee number matches this pattern. Pass empty to match any callee number.
        realCalleeIdPattern -- Use above caller number of the real callee number (a number with prefix) matches this pattern. This could be used if you want to allow user to pick up a specific caller number by adding a prefix to a called number. Pass empty to match any real callee number.
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def addCallerIdAsync(self, callerNumber, calleeIdPattern, realCalleeIdPattern, context=None):
            return _M_Smartswitch.Peer.UserGroup._op_addCallerId.invokeAsync(self, ((callerNumber, calleeIdPattern, realCalleeIdPattern), context))

        """
        @brief Attach the new UserCallerId replacement rule to the UserGroup.
        Arguments:
        callerNumber -- The caller number to bind to the UserGroup.
        calleeIdPattern -- Use above caller number of the callee number matches this pattern. Pass empty to match any callee number.
        realCalleeIdPattern -- Use above caller number of the real callee number (a number with prefix) matches this pattern. This could be used if you want to allow user to pick up a specific caller number by adding a prefix to a called number. Pass empty to match any real callee number.
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_addCallerId(self, callerNumber, calleeIdPattern, realCalleeIdPattern, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Peer.UserGroup._op_addCallerId.begin(self, ((callerNumber, calleeIdPattern, realCalleeIdPattern), _response, _ex, _sent, context))

        """
        @brief Attach the new UserCallerId replacement rule to the UserGroup.
        Arguments:
        callerNumber -- The caller number to bind to the UserGroup.
        calleeIdPattern -- Use above caller number of the callee number matches this pattern. Pass empty to match any callee number.
        realCalleeIdPattern -- Use above caller number of the real callee number (a number with prefix) matches this pattern. This could be used if you want to allow user to pick up a specific caller number by adding a prefix to a called number. Pass empty to match any real callee number.
        Returns: The proxy for UserCallerId which is attached to the UserGroup.
        """
        def end_addCallerId(self, _r):
            return _M_Smartswitch.Peer.UserGroup._op_addCallerId.end(self, _r)

        @staticmethod
        def checkedCast(proxy, facetOrContext=None, context=None):
            return _M_Smartswitch.Peer.UserGroupPrx.ice_checkedCast(proxy, '::Smartswitch::Peer::UserGroup', facetOrContext, context)

        @staticmethod
        def uncheckedCast(proxy, facet=None):
            return _M_Smartswitch.Peer.UserGroupPrx.ice_uncheckedCast(proxy, facet)

        @staticmethod
        def ice_staticId():
            return '::Smartswitch::Peer::UserGroup'
    _M_Smartswitch.Peer._t_UserGroupPrx = IcePy.defineProxy('::Smartswitch::Peer::UserGroup', UserGroupPrx)

    _M_Smartswitch.Peer.UserGroupPrx = UserGroupPrx
    del UserGroupPrx

    _M_Smartswitch.Peer.UserGroup = Ice.createTempClass()
    class UserGroup(_M_Smartswitch.Peer.GenericPeer):

        def ice_ids(self, current=None):
            return ('::Ice::Object', '::Smartswitch::Destroyable', '::Smartswitch::Peer::GenericPeer', '::Smartswitch::Peer::UserGroup')

        def ice_id(self, current=None):
            return '::Smartswitch::Peer::UserGroup'

        @staticmethod
        def ice_staticId():
            return '::Smartswitch::Peer::UserGroup'

        def getCallerIds(self, current=None):
            """
            @brief Obtain the UserCallerId objects attached to the UserGroup.
            These settings are used by the Smartswitch to replace a caller number and caller name for the calls from any User of the UserGroup.
            This is needed to bind a specific A-number and A-name to the user, so that he won't be able to call using other user's caller information.
            The latter is considered a crime in many countries and thus it's needed to use this function in a safe User configuration.
            Arguments:
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'getCallerIds' not implemented")

        def addCallerId(self, callerNumber, calleeIdPattern, realCalleeIdPattern, current=None):
            """
            @brief Attach the new UserCallerId replacement rule to the UserGroup.
            Arguments:
            callerNumber -- The caller number to bind to the UserGroup.
            calleeIdPattern -- Use above caller number of the callee number matches this pattern. Pass empty to match any callee number.
            realCalleeIdPattern -- Use above caller number of the real callee number (a number with prefix) matches this pattern. This could be used if you want to allow user to pick up a specific caller number by adding a prefix to a called number. Pass empty to match any real callee number.
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'addCallerId' not implemented")

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Peer._t_UserGroupDisp)

        __repr__ = __str__

    _M_Smartswitch.Peer._t_UserGroupDisp = IcePy.defineClass('::Smartswitch::Peer::UserGroup', UserGroup, (), None, (_M_Smartswitch.Peer._t_GenericPeerDisp,))
    UserGroup._ice_type = _M_Smartswitch.Peer._t_UserGroupDisp

    UserGroup._op_getCallerIds = IcePy.Operation('getCallerIds', Ice.OperationMode.Normal, Ice.OperationMode.Normal, False, None, (), (), (), ((), _M_Smartswitch.Peer._t_UserCallerIdSequence, False, 0), (_M_Smartswitch._t_AccessException,))
    UserGroup._op_addCallerId = IcePy.Operation('addCallerId', Ice.OperationMode.Normal, Ice.OperationMode.Normal, False, None, (), (((), IcePy._t_string, False, 0), ((), IcePy._t_string, False, 0), ((), IcePy._t_string, False, 0)), (), ((), _M_Smartswitch.Peer._t_UserCallerIdPrx, False, 0), (_M_Smartswitch._t_AccessException, _M_Smartswitch._t_DuplicateException))

    _M_Smartswitch.Peer.UserGroup = UserGroup
    del UserGroup

# End of module Smartswitch.Peer

__name__ = 'Smartswitch'

# End of module Smartswitch
