# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `Cdr.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Config_ice
import Smartswitch.Common_ice
import Smartswitch.Peer.PeerType_ice
import Smartswitch.Direction_ice

# Included module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')

# Included module Smartswitch.Peer
_M_Smartswitch.Peer = Ice.openModule('Smartswitch.Peer')

# Start of module Smartswitch
__name__ = 'Smartswitch'

# Start of module Smartswitch.Telephony
_M_Smartswitch.Telephony = Ice.openModule('Smartswitch.Telephony')
__name__ = 'Smartswitch.Telephony'

if 'CdrBilling' not in _M_Smartswitch.Telephony.__dict__:
    _M_Smartswitch.Telephony.CdrBilling = Ice.createTempClass()
    class CdrBilling(object):
        """
        The struct defines the biling-part of a CDR.
        Members:
        code -- < E.164 billing code.
        tollFree -- < `true` if the callee pays.
        minutes -- < The duration of a call in minutes according to `billing increment`, `minimum` and `free` seconds.
        price -- < The full price of a call.
        currency -- < The name of the currency in which the `price` is calculated.
        """
        def __init__(self, code='', tollFree=False, minutes=0.0, price=0.0, currency=''):
            self.code = code
            self.tollFree = tollFree
            self.minutes = minutes
            self.price = price
            self.currency = currency

        def __eq__(self, other):
            if other is None:
                return False
            elif not isinstance(other, _M_Smartswitch.Telephony.CdrBilling):
                return NotImplemented
            else:
                if self.code != other.code:
                    return False
                if self.tollFree != other.tollFree:
                    return False
                if self.minutes != other.minutes:
                    return False
                if self.price != other.price:
                    return False
                if self.currency != other.currency:
                    return False
                return True

        def __ne__(self, other):
            return not self.__eq__(other)

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Telephony._t_CdrBilling)

        __repr__ = __str__

    _M_Smartswitch.Telephony._t_CdrBilling = IcePy.defineStruct('::Smartswitch::Telephony::CdrBilling', CdrBilling, (), (
        ('code', (), IcePy._t_string),
        ('tollFree', (), IcePy._t_bool),
        ('minutes', (), IcePy._t_double),
        ('price', (), IcePy._t_double),
        ('currency', (), IcePy._t_string)
    ))

    _M_Smartswitch.Telephony.CdrBilling = CdrBilling
    del CdrBilling

if '_t_CdrBillingOpt' not in _M_Smartswitch.Telephony.__dict__:
    _M_Smartswitch.Telephony._t_CdrBillingOpt = IcePy.defineSequence('::Smartswitch::Telephony::CdrBillingOpt', (), _M_Smartswitch.Telephony._t_CdrBilling)

if 'Cdr' not in _M_Smartswitch.Telephony.__dict__:
    _M_Smartswitch.Telephony.Cdr = Ice.createTempClass()
    class Cdr(object):
        """
        The struct defines the Call Detail Record for one call leg.
        Members:
        startTime -- < The time a call appeared on Smartswitch.
        answerTime -- < The time a call was answered on Smartswitch.
        endTime -- < The time a call ended on Smartswitch.
        technology -- < The technology of a call, for example `SIP`.
        callerId -- < A-number of a call.
        calleeId -- < B-number of a call.
        totalSeconds -- < The rounded duration of a call in seconds from `startTime` to `endTime`.
        answeredSeconds -- < The rounded duration of a call in seconds from `answerTime` to `endTime`.
        hangupCause -- < Human-readable Q.850/Q.931 hangup reason.
        billing -- < If billing is available for this call, the array contains 1 element with it. The array is empty otherwise.
        direction -- < The Direction of a call from the POV of Smartswitch.
        peerType -- < A type of a Peer to which this call leg is assigned.
        peerId -- < An ID of a Peer to which this call leg is assigned.
        """
        def __init__(self, startTime='', answerTime='', endTime='', technology='', callerId='', calleeId='', totalSeconds=0, answeredSeconds=0, hangupCause='', billing=None, direction=_M_Smartswitch.Direction.Inbound, peerType=_M_Smartswitch.Peer.PeerType.Originator, peerId=0):
            self.startTime = startTime
            self.answerTime = answerTime
            self.endTime = endTime
            self.technology = technology
            self.callerId = callerId
            self.calleeId = calleeId
            self.totalSeconds = totalSeconds
            self.answeredSeconds = answeredSeconds
            self.hangupCause = hangupCause
            self.billing = billing
            self.direction = direction
            self.peerType = peerType
            self.peerId = peerId

        def __eq__(self, other):
            if other is None:
                return False
            elif not isinstance(other, _M_Smartswitch.Telephony.Cdr):
                return NotImplemented
            else:
                if self.startTime != other.startTime:
                    return False
                if self.answerTime != other.answerTime:
                    return False
                if self.endTime != other.endTime:
                    return False
                if self.technology != other.technology:
                    return False
                if self.callerId != other.callerId:
                    return False
                if self.calleeId != other.calleeId:
                    return False
                if self.totalSeconds != other.totalSeconds:
                    return False
                if self.answeredSeconds != other.answeredSeconds:
                    return False
                if self.hangupCause != other.hangupCause:
                    return False
                if self.billing != other.billing:
                    return False
                if self.direction != other.direction:
                    return False
                if self.peerType != other.peerType:
                    return False
                if self.peerId != other.peerId:
                    return False
                return True

        def __ne__(self, other):
            return not self.__eq__(other)

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Telephony._t_Cdr)

        __repr__ = __str__

    _M_Smartswitch.Telephony._t_Cdr = IcePy.defineStruct('::Smartswitch::Telephony::Cdr', Cdr, (), (
        ('startTime', (), IcePy._t_string),
        ('answerTime', (), IcePy._t_string),
        ('endTime', (), IcePy._t_string),
        ('technology', (), IcePy._t_string),
        ('callerId', (), IcePy._t_string),
        ('calleeId', (), IcePy._t_string),
        ('totalSeconds', (), IcePy._t_int),
        ('answeredSeconds', (), IcePy._t_int),
        ('hangupCause', (), IcePy._t_string),
        ('billing', (), _M_Smartswitch.Telephony._t_CdrBillingOpt),
        ('direction', (), _M_Smartswitch._t_Direction),
        ('peerType', (), _M_Smartswitch.Peer._t_PeerType),
        ('peerId', (), IcePy._t_long)
    ))

    _M_Smartswitch.Telephony.Cdr = Cdr
    del Cdr

if '_t_CdrSequence' not in _M_Smartswitch.Telephony.__dict__:
    _M_Smartswitch.Telephony._t_CdrSequence = IcePy.defineSequence('::Smartswitch::Telephony::CdrSequence', (), _M_Smartswitch.Telephony._t_Cdr)

# End of module Smartswitch.Telephony

__name__ = 'Smartswitch'

# End of module Smartswitch
