# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `ChannelInfo.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Config_ice
import Smartswitch.Common_ice
import Smartswitch.Direction_ice
import Smartswitch.Billing.CurrencyAmount_ice

# Included module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')

# Included module Smartswitch.Billing
_M_Smartswitch.Billing = Ice.openModule('Smartswitch.Billing')

# Start of module Smartswitch
__name__ = 'Smartswitch'

# Start of module Smartswitch.Telephony
_M_Smartswitch.Telephony = Ice.openModule('Smartswitch.Telephony')
__name__ = 'Smartswitch.Telephony'

if 'ChannelBilling' not in _M_Smartswitch.Telephony.__dict__:
    _M_Smartswitch.Telephony.ChannelBilling = Ice.createTempClass()
    class ChannelBilling(object):
        """
        The struct defines the biling-part of a ChannelInfo.
        Members:
        code -- < E.164 billing code.
        currency -- < The name of the currency in which the `price` is calculated.
        price -- < The full price of a call.
        minutePrice -- < The price of 1 minute of a call.
        """
        def __init__(self, code='', currency='', price=0.0, minutePrice=0.0):
            self.code = code
            self.currency = currency
            self.price = price
            self.minutePrice = minutePrice

        def __eq__(self, other):
            if other is None:
                return False
            elif not isinstance(other, _M_Smartswitch.Telephony.ChannelBilling):
                return NotImplemented
            else:
                if self.code != other.code:
                    return False
                if self.currency != other.currency:
                    return False
                if self.price != other.price:
                    return False
                if self.minutePrice != other.minutePrice:
                    return False
                return True

        def __ne__(self, other):
            return not self.__eq__(other)

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Telephony._t_ChannelBilling)

        __repr__ = __str__

    _M_Smartswitch.Telephony._t_ChannelBilling = IcePy.defineStruct('::Smartswitch::Telephony::ChannelBilling', ChannelBilling, (), (
        ('code', (), IcePy._t_string),
        ('currency', (), IcePy._t_string),
        ('price', (), IcePy._t_double),
        ('minutePrice', (), IcePy._t_double)
    ))

    _M_Smartswitch.Telephony.ChannelBilling = ChannelBilling
    del ChannelBilling

if '_t_ChannelBillingOpt' not in _M_Smartswitch.Telephony.__dict__:
    _M_Smartswitch.Telephony._t_ChannelBillingOpt = IcePy.defineSequence('::Smartswitch::Telephony::ChannelBillingOpt', (), _M_Smartswitch.Telephony._t_ChannelBilling)

if 'ChannelInfo' not in _M_Smartswitch.Telephony.__dict__:
    _M_Smartswitch.Telephony.ChannelInfo = Ice.createTempClass()
    class ChannelInfo(object):
        """
        The struct defines the information about a currently active channel.
        Members:
        channelId -- < The unique ID of a channel
        channelName -- < The name of a channel.
        startTime -- < The time a channel has been created on Smartswitch.
        answerTime -- < The time a channel was answered on Smartswitch.
        sessionId -- < The ID of a session. It's common for all bridged legs.
        direction -- < The Direction of a leg from the POV of Smartswitch.
        technology -- < The technology of a channel, for ex. `SIP`.
        callerId -- < The billing A-number of a leg (without prefix).
        calleeId -- < The billing B-number of a leg (without prefix).
        realCallerId -- < The A-number of a leg (including prefix) as it came ingress or sent egress from Smartswitch.
        realCalleeId -- < The B-number of a leg (including prefix) as it came ingress or sent egress from Smartswitch.
        peerName -- < The name of a GenericPeer descendant involved with the leg.
        inboundCodec -- < The codec used for inbound (from POV of Smartswitch) stream.
        outboundCodec -- < The codec used for outbound (from POV of Smartswitch) stream.
        ipAddress -- < The IP address of a peer.
        billing -- < If billing is available for this call, the array contains 1 element with it. The array is empty otherwise.
        """
        def __init__(self, channelId='', channelName='', startTime='', answerTime='', sessionId='', direction=_M_Smartswitch.Direction.Inbound, technology='', callerId='', calleeId='', realCallerId='', realCalleeId='', peerName='', inboundCodec='', outboundCodec='', ipAddress='', billing=None):
            self.channelId = channelId
            self.channelName = channelName
            self.startTime = startTime
            self.answerTime = answerTime
            self.sessionId = sessionId
            self.direction = direction
            self.technology = technology
            self.callerId = callerId
            self.calleeId = calleeId
            self.realCallerId = realCallerId
            self.realCalleeId = realCalleeId
            self.peerName = peerName
            self.inboundCodec = inboundCodec
            self.outboundCodec = outboundCodec
            self.ipAddress = ipAddress
            self.billing = billing

        def __eq__(self, other):
            if other is None:
                return False
            elif not isinstance(other, _M_Smartswitch.Telephony.ChannelInfo):
                return NotImplemented
            else:
                if self.channelId != other.channelId:
                    return False
                if self.channelName != other.channelName:
                    return False
                if self.startTime != other.startTime:
                    return False
                if self.answerTime != other.answerTime:
                    return False
                if self.sessionId != other.sessionId:
                    return False
                if self.direction != other.direction:
                    return False
                if self.technology != other.technology:
                    return False
                if self.callerId != other.callerId:
                    return False
                if self.calleeId != other.calleeId:
                    return False
                if self.realCallerId != other.realCallerId:
                    return False
                if self.realCalleeId != other.realCalleeId:
                    return False
                if self.peerName != other.peerName:
                    return False
                if self.inboundCodec != other.inboundCodec:
                    return False
                if self.outboundCodec != other.outboundCodec:
                    return False
                if self.ipAddress != other.ipAddress:
                    return False
                if self.billing != other.billing:
                    return False
                return True

        def __ne__(self, other):
            return not self.__eq__(other)

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Telephony._t_ChannelInfo)

        __repr__ = __str__

    _M_Smartswitch.Telephony._t_ChannelInfo = IcePy.defineStruct('::Smartswitch::Telephony::ChannelInfo', ChannelInfo, (), (
        ('channelId', (), IcePy._t_string),
        ('channelName', (), IcePy._t_string),
        ('startTime', (), IcePy._t_string),
        ('answerTime', (), IcePy._t_string),
        ('sessionId', (), IcePy._t_string),
        ('direction', (), _M_Smartswitch._t_Direction),
        ('technology', (), IcePy._t_string),
        ('callerId', (), IcePy._t_string),
        ('calleeId', (), IcePy._t_string),
        ('realCallerId', (), IcePy._t_string),
        ('realCalleeId', (), IcePy._t_string),
        ('peerName', (), IcePy._t_string),
        ('inboundCodec', (), IcePy._t_string),
        ('outboundCodec', (), IcePy._t_string),
        ('ipAddress', (), IcePy._t_string),
        ('billing', (), _M_Smartswitch.Telephony._t_ChannelBillingOpt)
    ))

    _M_Smartswitch.Telephony.ChannelInfo = ChannelInfo
    del ChannelInfo

if '_t_ChannelInfoSequence' not in _M_Smartswitch.Telephony.__dict__:
    _M_Smartswitch.Telephony._t_ChannelInfoSequence = IcePy.defineSequence('::Smartswitch::Telephony::ChannelInfoSequence', (), _M_Smartswitch.Telephony._t_ChannelInfo)

# End of module Smartswitch.Telephony

__name__ = 'Smartswitch'

# End of module Smartswitch
