# -*- coding: utf-8 -*-
#
# Copyright (c) ZeroC, Inc. All rights reserved.
#
#
# Ice version 3.7.2
#
# <auto-generated>
#
# Generated from file `Number.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

from sys import version_info as _version_info_
import Ice, IcePy
import Smartswitch.Config_ice
import Smartswitch.Destroyable_ice
import Smartswitch.EmptyArgumentException_ice

# Included module Smartswitch
_M_Smartswitch = Ice.openModule('Smartswitch')

# Start of module Smartswitch
__name__ = 'Smartswitch'

# Start of module Smartswitch.Telephony
_M_Smartswitch.Telephony = Ice.openModule('Smartswitch.Telephony')
__name__ = 'Smartswitch.Telephony'

# Start of module Smartswitch.Telephony.Forwarding
_M_Smartswitch.Telephony.Forwarding = Ice.openModule('Smartswitch.Telephony.Forwarding')
__name__ = 'Smartswitch.Telephony.Forwarding'

_M_Smartswitch.Telephony.Forwarding._t_Number = IcePy.defineValue('::Smartswitch::Telephony::Forwarding::Number', Ice.Value, -1, (), False, True, None, ())

if 'NumberPrx' not in _M_Smartswitch.Telephony.Forwarding.__dict__:
    _M_Smartswitch.Telephony.Forwarding.NumberPrx = Ice.createTempClass()
    class NumberPrx(_M_Smartswitch.DestroyablePrx):

        """
        Obtain a forwarding number.
        Arguments:
        context -- The request context for the invocation.
        Returns: The dialed forwarding number.
        """
        def getNumber(self, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getNumber.invoke(self, ((), context))

        """
        Obtain a forwarding number.
        Arguments:
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def getNumberAsync(self, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getNumber.invokeAsync(self, ((), context))

        """
        Obtain a forwarding number.
        Arguments:
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_getNumber(self, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getNumber.begin(self, ((), _response, _ex, _sent, context))

        """
        Obtain a forwarding number.
        Arguments:
        Returns: The dialed forwarding number.
        """
        def end_getNumber(self, _r):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getNumber.end(self, _r)

        """
        Set a forwarding number.
        Arguments:
        number -- The dialed forwarding number.
        context -- The request context for the invocation.
        """
        def setNumber(self, number, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setNumber.invoke(self, ((number, ), context))

        """
        Set a forwarding number.
        Arguments:
        number -- The dialed forwarding number.
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def setNumberAsync(self, number, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setNumber.invokeAsync(self, ((number, ), context))

        """
        Set a forwarding number.
        Arguments:
        number -- The dialed forwarding number.
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_setNumber(self, number, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setNumber.begin(self, ((number, ), _response, _ex, _sent, context))

        """
        Set a forwarding number.
        Arguments:
        number -- The dialed forwarding number.
        """
        def end_setNumber(self, _r):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setNumber.end(self, _r)

        """
        @brief Obtain a dial delay for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the delay of dialing the forwarding numbers.
        Arguments:
        context -- The request context for the invocation.
        Returns: The dial delay in seconds.
        """
        def getDialDelay(self, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getDialDelay.invoke(self, ((), context))

        """
        @brief Obtain a dial delay for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the delay of dialing the forwarding numbers.
        Arguments:
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def getDialDelayAsync(self, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getDialDelay.invokeAsync(self, ((), context))

        """
        @brief Obtain a dial delay for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the delay of dialing the forwarding numbers.
        Arguments:
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_getDialDelay(self, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getDialDelay.begin(self, ((), _response, _ex, _sent, context))

        """
        @brief Obtain a dial delay for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the delay of dialing the forwarding numbers.
        Arguments:
        Returns: The dial delay in seconds.
        """
        def end_getDialDelay(self, _r):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getDialDelay.end(self, _r)

        """
        @brief Set a dial delay for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the delay of dialing the forwarding numbers.
        Arguments:
        dialDelay -- The dial delay in seconds.
        context -- The request context for the invocation.
        """
        def setDialDelay(self, dialDelay, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setDialDelay.invoke(self, ((dialDelay, ), context))

        """
        @brief Set a dial delay for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the delay of dialing the forwarding numbers.
        Arguments:
        dialDelay -- The dial delay in seconds.
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def setDialDelayAsync(self, dialDelay, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setDialDelay.invokeAsync(self, ((dialDelay, ), context))

        """
        @brief Set a dial delay for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the delay of dialing the forwarding numbers.
        Arguments:
        dialDelay -- The dial delay in seconds.
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_setDialDelay(self, dialDelay, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setDialDelay.begin(self, ((dialDelay, ), _response, _ex, _sent, context))

        """
        @brief Set a dial delay for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the delay of dialing the forwarding numbers.
        Arguments:
        dialDelay -- The dial delay in seconds.
        """
        def end_setDialDelay(self, _r):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setDialDelay.end(self, _r)

        """
        @brief Obtain a dial timeout for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before cancelling a dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the timeout of dialing the forwarding numbers.
        Arguments:
        context -- The request context for the invocation.
        Returns: The dial timeout in seconds.
        """
        def getDialTimeout(self, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getDialTimeout.invoke(self, ((), context))

        """
        @brief Obtain a dial timeout for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before cancelling a dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the timeout of dialing the forwarding numbers.
        Arguments:
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def getDialTimeoutAsync(self, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getDialTimeout.invokeAsync(self, ((), context))

        """
        @brief Obtain a dial timeout for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before cancelling a dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the timeout of dialing the forwarding numbers.
        Arguments:
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_getDialTimeout(self, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getDialTimeout.begin(self, ((), _response, _ex, _sent, context))

        """
        @brief Obtain a dial timeout for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before cancelling a dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the timeout of dialing the forwarding numbers.
        Arguments:
        Returns: The dial timeout in seconds.
        """
        def end_getDialTimeout(self, _r):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getDialTimeout.end(self, _r)

        """
        @brief Set a dial timeout for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before cancelling a dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the timeout of dialing the forwarding numbers.
        Arguments:
        dialTimeout -- The dial timeout in seconds.
        context -- The request context for the invocation.
        """
        def setDialTimeout(self, dialTimeout, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setDialTimeout.invoke(self, ((dialTimeout, ), context))

        """
        @brief Set a dial timeout for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before cancelling a dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the timeout of dialing the forwarding numbers.
        Arguments:
        dialTimeout -- The dial timeout in seconds.
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def setDialTimeoutAsync(self, dialTimeout, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setDialTimeout.invokeAsync(self, ((dialTimeout, ), context))

        """
        @brief Set a dial timeout for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before cancelling a dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the timeout of dialing the forwarding numbers.
        Arguments:
        dialTimeout -- The dial timeout in seconds.
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_setDialTimeout(self, dialTimeout, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setDialTimeout.begin(self, ((dialTimeout, ), _response, _ex, _sent, context))

        """
        @brief Set a dial timeout for a given `forwarding number`.
        It indicates the amount of seconds Smartswitch will wait before cancelling a dialing this number.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the timeout of dialing the forwarding numbers.
        Arguments:
        dialTimeout -- The dial timeout in seconds.
        """
        def end_setDialTimeout(self, _r):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setDialTimeout.end(self, _r)

        """
        @brief Obtain a priority for a given `forwarding number`.
        It indicates the order of dialing this number among other forwarding numbers.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the order of dialing the forwarding numbers.
        Arguments:
        context -- The request context for the invocation.
        Returns: The priority (the greater - the less is the priority).
        """
        def getPriority(self, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getPriority.invoke(self, ((), context))

        """
        @brief Obtain a priority for a given `forwarding number`.
        It indicates the order of dialing this number among other forwarding numbers.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the order of dialing the forwarding numbers.
        Arguments:
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def getPriorityAsync(self, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getPriority.invokeAsync(self, ((), context))

        """
        @brief Obtain a priority for a given `forwarding number`.
        It indicates the order of dialing this number among other forwarding numbers.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the order of dialing the forwarding numbers.
        Arguments:
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_getPriority(self, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getPriority.begin(self, ((), _response, _ex, _sent, context))

        """
        @brief Obtain a priority for a given `forwarding number`.
        It indicates the order of dialing this number among other forwarding numbers.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the order of dialing the forwarding numbers.
        Arguments:
        Returns: The priority (the greater - the less is the priority).
        """
        def end_getPriority(self, _r):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_getPriority.end(self, _r)

        """
        @brief Set a priority for a given `forwarding number`.
        It indicates the order of dialing this number among other forwarding numbers.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the order of dialing the forwarding numbers.
        Arguments:
        priority -- The priority (the greater - the less is the priority).
        context -- The request context for the invocation.
        """
        def setPriority(self, priority, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setPriority.invoke(self, ((priority, ), context))

        """
        @brief Set a priority for a given `forwarding number`.
        It indicates the order of dialing this number among other forwarding numbers.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the order of dialing the forwarding numbers.
        Arguments:
        priority -- The priority (the greater - the less is the priority).
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def setPriorityAsync(self, priority, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setPriority.invokeAsync(self, ((priority, ), context))

        """
        @brief Set a priority for a given `forwarding number`.
        It indicates the order of dialing this number among other forwarding numbers.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the order of dialing the forwarding numbers.
        Arguments:
        priority -- The priority (the greater - the less is the priority).
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_setPriority(self, priority, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setPriority.begin(self, ((priority, ), _response, _ex, _sent, context))

        """
        @brief Set a priority for a given `forwarding number`.
        It indicates the order of dialing this number among other forwarding numbers.
        It's useful when you forward to several numbers and want to have a delay between them.
        Using this parameter you can control the order of dialing the forwarding numbers.
        Arguments:
        priority -- The priority (the greater - the less is the priority).
        """
        def end_setPriority(self, _r):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_setPriority.end(self, _r)

        """
        Remove a given Number.
        Arguments:
        context -- The request context for the invocation.
        """
        def remove(self, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_remove.invoke(self, ((), context))

        """
        Remove a given Number.
        Arguments:
        context -- The request context for the invocation.
        Returns: A future object for the invocation.
        """
        def removeAsync(self, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_remove.invokeAsync(self, ((), context))

        """
        Remove a given Number.
        Arguments:
        _response -- The asynchronous response callback.
        _ex -- The asynchronous exception callback.
        _sent -- The asynchronous sent callback.
        context -- The request context for the invocation.
        Returns: An asynchronous result object for the invocation.
        """
        def begin_remove(self, _response=None, _ex=None, _sent=None, context=None):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_remove.begin(self, ((), _response, _ex, _sent, context))

        """
        Remove a given Number.
        Arguments:
        """
        def end_remove(self, _r):
            return _M_Smartswitch.Telephony.Forwarding.Number._op_remove.end(self, _r)

        @staticmethod
        def checkedCast(proxy, facetOrContext=None, context=None):
            return _M_Smartswitch.Telephony.Forwarding.NumberPrx.ice_checkedCast(proxy, '::Smartswitch::Telephony::Forwarding::Number', facetOrContext, context)

        @staticmethod
        def uncheckedCast(proxy, facet=None):
            return _M_Smartswitch.Telephony.Forwarding.NumberPrx.ice_uncheckedCast(proxy, facet)

        @staticmethod
        def ice_staticId():
            return '::Smartswitch::Telephony::Forwarding::Number'
    _M_Smartswitch.Telephony.Forwarding._t_NumberPrx = IcePy.defineProxy('::Smartswitch::Telephony::Forwarding::Number', NumberPrx)

    _M_Smartswitch.Telephony.Forwarding.NumberPrx = NumberPrx
    del NumberPrx

    _M_Smartswitch.Telephony.Forwarding.Number = Ice.createTempClass()
    class Number(_M_Smartswitch.Destroyable):

        def ice_ids(self, current=None):
            return ('::Ice::Object', '::Smartswitch::Destroyable', '::Smartswitch::Telephony::Forwarding::Number')

        def ice_id(self, current=None):
            return '::Smartswitch::Telephony::Forwarding::Number'

        @staticmethod
        def ice_staticId():
            return '::Smartswitch::Telephony::Forwarding::Number'

        def getNumber(self, current=None):
            """
            Obtain a forwarding number.
            Arguments:
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'getNumber' not implemented")

        def setNumber(self, number, current=None):
            """
            Set a forwarding number.
            Arguments:
            number -- The dialed forwarding number.
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'setNumber' not implemented")

        def getDialDelay(self, current=None):
            """
            @brief Obtain a dial delay for a given `forwarding number`.
            It indicates the amount of seconds Smartswitch will wait before dialing this number.
            It's useful when you forward to several numbers and want to have a delay between them.
            Using this parameter you can control the delay of dialing the forwarding numbers.
            Arguments:
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'getDialDelay' not implemented")

        def setDialDelay(self, dialDelay, current=None):
            """
            @brief Set a dial delay for a given `forwarding number`.
            It indicates the amount of seconds Smartswitch will wait before dialing this number.
            It's useful when you forward to several numbers and want to have a delay between them.
            Using this parameter you can control the delay of dialing the forwarding numbers.
            Arguments:
            dialDelay -- The dial delay in seconds.
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'setDialDelay' not implemented")

        def getDialTimeout(self, current=None):
            """
            @brief Obtain a dial timeout for a given `forwarding number`.
            It indicates the amount of seconds Smartswitch will wait before cancelling a dialing this number.
            It's useful when you forward to several numbers and want to have a delay between them.
            Using this parameter you can control the timeout of dialing the forwarding numbers.
            Arguments:
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'getDialTimeout' not implemented")

        def setDialTimeout(self, dialTimeout, current=None):
            """
            @brief Set a dial timeout for a given `forwarding number`.
            It indicates the amount of seconds Smartswitch will wait before cancelling a dialing this number.
            It's useful when you forward to several numbers and want to have a delay between them.
            Using this parameter you can control the timeout of dialing the forwarding numbers.
            Arguments:
            dialTimeout -- The dial timeout in seconds.
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'setDialTimeout' not implemented")

        def getPriority(self, current=None):
            """
            @brief Obtain a priority for a given `forwarding number`.
            It indicates the order of dialing this number among other forwarding numbers.
            It's useful when you forward to several numbers and want to have a delay between them.
            Using this parameter you can control the order of dialing the forwarding numbers.
            Arguments:
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'getPriority' not implemented")

        def setPriority(self, priority, current=None):
            """
            @brief Set a priority for a given `forwarding number`.
            It indicates the order of dialing this number among other forwarding numbers.
            It's useful when you forward to several numbers and want to have a delay between them.
            Using this parameter you can control the order of dialing the forwarding numbers.
            Arguments:
            priority -- The priority (the greater - the less is the priority).
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'setPriority' not implemented")

        def remove(self, current=None):
            """
            Remove a given Number.
            Arguments:
            current -- The Current object for the invocation.
            Returns: A future object for the invocation.
            """
            raise NotImplementedError("servant method 'remove' not implemented")

        def __str__(self):
            return IcePy.stringify(self, _M_Smartswitch.Telephony.Forwarding._t_NumberDisp)

        __repr__ = __str__

    _M_Smartswitch.Telephony.Forwarding._t_NumberDisp = IcePy.defineClass('::Smartswitch::Telephony::Forwarding::Number', Number, (), None, (_M_Smartswitch._t_DestroyableDisp,))
    Number._ice_type = _M_Smartswitch.Telephony.Forwarding._t_NumberDisp

    Number._op_getNumber = IcePy.Operation('getNumber', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (), (), ((), IcePy._t_string, False, 0), ())
    Number._op_setNumber = IcePy.Operation('setNumber', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (((), IcePy._t_string, False, 0),), (), None, (_M_Smartswitch._t_EmptyArgumentException,))
    Number._op_getDialDelay = IcePy.Operation('getDialDelay', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (), (), ((), IcePy._t_int, False, 0), ())
    Number._op_setDialDelay = IcePy.Operation('setDialDelay', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (((), IcePy._t_int, False, 0),), (), None, (_M_Smartswitch._t_ArgumentException,))
    Number._op_getDialTimeout = IcePy.Operation('getDialTimeout', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (), (), ((), IcePy._t_int, False, 0), ())
    Number._op_setDialTimeout = IcePy.Operation('setDialTimeout', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (((), IcePy._t_int, False, 0),), (), None, (_M_Smartswitch._t_ArgumentException,))
    Number._op_getPriority = IcePy.Operation('getPriority', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (), (), ((), IcePy._t_int, False, 0), ())
    Number._op_setPriority = IcePy.Operation('setPriority', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, False, None, (), (((), IcePy._t_int, False, 0),), (), None, ())
    Number._op_remove = IcePy.Operation('remove', Ice.OperationMode.Normal, Ice.OperationMode.Normal, False, None, (), (), (), None, ())

    _M_Smartswitch.Telephony.Forwarding.Number = Number
    del Number

if '_t_NumberSequence' not in _M_Smartswitch.Telephony.Forwarding.__dict__:
    _M_Smartswitch.Telephony.Forwarding._t_NumberSequence = IcePy.defineSequence('::Smartswitch::Telephony::Forwarding::NumberSequence', (), _M_Smartswitch.Telephony.Forwarding._t_NumberPrx)

# End of module Smartswitch.Telephony.Forwarding

__name__ = 'Smartswitch.Telephony'

# End of module Smartswitch.Telephony

__name__ = 'Smartswitch'

# End of module Smartswitch
